/*
  *** PocketMotus GBA ***
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <stdlib.h>
#include <string.h>
#include "../gba.h"
#include "global.h"
#include "game.h"


BOOL RandomChoose (char *store_buffer)
{
  int i, j, number_possible_chars ;
  unsigned char tmp_char, possible_chars[256] ;
  DAGElement bucket ;
  unsigned long base ;

  if (initial_state == END_TRANSITION) return (FALSE) ;
  base = initial_state ;
  for (i=0; i<WORD_LEN; i++) {
    number_possible_chars = 0 ;
    for (j=1; j<256; j++) {
      // On vrifie que l'on ne sort pas du dictionnaire
      if ((base + j) < automaton_size) {
	bucket = automaton[base + j] ;
	tmp_char = GETCHAR (bucket) ;
	// On vrifie si la case est bien utilise (inutile je pense en fait)
	if (tmp_char != '\0') {
	  // On vrifie s'il existe une transition sur le caractre du mot
	  if (tmp_char == j) {
	    possible_chars[number_possible_chars] = (unsigned char) j ;
	    number_possible_chars++ ;
	  }			// End of if (tmp_char == j)
	}			// End of (tmp_char != '\0')
      }				// End of if ((base + j) < automaton_size)
    }				// End of for (j=1; j<256; j++)

    // Now 'possible_chars' contains all the characters amongst those one
    // must randomly chose one to get one more letter for our random word.
    if (number_possible_chars == 0) return (FALSE) ;
    tmp_char = possible_chars[rand () % number_possible_chars] ;
    store_buffer[i] = (char) tmp_char ;
    bucket = automaton[base + tmp_char] ;
    base = GETNEXTBASE (bucket) ;
  }				// End of for (i=0; i<WORD_LEN; i++)

  // Close the found word.
  store_buffer[WORD_LEN] = '\0' ;
  // Final and successful return.
  return (TRUE) ;
}


