/*
  *** PocketMotus GBA ***
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <stdio.h>
#include <gba.h>
#include <screen_mode.h>
#include "global.h"
#include "game.h"

DAGElement *automaton = NULL ;
unsigned long automaton_size = 0 ;
unsigned long initial_state = END_TRANSITION ;

const unsigned long french_dic_mapped_memory[] __attribute__ ((section (".rodata"))) =
{
  /* 0x4d444943 : M D I C */
#include "data/raw_french_dic_data"
};

const unsigned long english_dic_mapped_memory[] __attribute__ ((section (".rodata"))) =
{
  /* 0x4d444943 : M D I C */
#include "data/raw_english_dic_data"
};



const unsigned long italiano_dic_mapped_memory[] __attribute__ ((section (".rodata"))) =
{
  /* 0x4d444943 : M D I C */
#include "data/raw_italiano_dic_data"
};


u8 language = LANG_FRENCH ;
struct game current_game ;
BOOL check_flag ;
BOOL timer_flag ;

u16 *palette_memory = BACKGROUND_PALETTE_ADDR ;
u16 *balls_video_memory = SCREEN_BASE_BLOCK_0_ADDR ;      /* 2Ko. */
u16 *background_video_memory = SCREEN_BASE_BLOCK_16_ADDR ;
u16 *requesters_video_memory = SCREEN_BASE_BLOCK_1_ADDR ;
struct sprite cursor_sprite = { 0, 0, 0, 0 } ;
u16 *sprite_palette = SPRITES_PALETTE_ADR ;
struct sprite *sprite_video_memory = SPRITES_INFO_MEMORY_ADR ;

unsigned char all_purpose_message_buffer[256] ;

u16 key_prev = 0xFFFF ;
u16 key_curr = 0xFFFF ;
