/*
  *** GBA Headers ***
 Franois PESSAUX June 2004
 This header is freeware. It was build from various other free information.
 I thank all people how contributed directly or indirectly to this header.

 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#ifndef __GBA_TIMER_H
#define __GBA_TIMER_H

#include <gba.h>

#define TIMER_FREQ_16_78_MHZ 0x0000
#define TIMER_FREQ_262_KHZ 0x0001
#define TIMER_FREQ_65_5_KHZ 0x0002
#define TIMER_FREQ_16_4_KHZ 0x0003

#define TIMER_CASCADING 0x0004
#define TIMER_OVERFLOW_INTERRUPT (1<<6)
#define TIMER_ON_BIT (1<<7)
#define SET_TIMER_ON(timer) (timer) |= TIMER_ON_BIT
#define SET_TIMER_OFF(timer) (timer) &= ~(TIMER_ON_BIT)

#endif
