#ifndef __PAUSE_GFX_H
#define __PAUSE_GFX_H

#define NB_PAUSE_PALETTE_ENTRIES 256
extern const u16 pause_palette[NB_PAUSE_PALETTE_ENTRIES] __attribute__ ((section (".rodata"))) ;

#define NB_PAUSE_TILES 137
extern const u8 pause_tiles[NB_PAUSE_TILES * 64] __attribute__ ((section (".rodata"))) ;
extern const u16 pause_map[30 * 20] __attribute__ ((section (".rodata"))) ;

#define PAUSE_OPTIONS_CONTINUE_Y_OFFSET (7 * 8)
#define PAUSE_OPTIONS_SURRENDER_Y_OFFSET (11 * 8)

#define PAUSE_OPTIONS_RIGHT_OFFSET (5 * 8)

#define SELECTION_CONTINUE 0
#define SELECTION_SURRENDER 1

#endif
