/*
  *** PocketMotus GBA ***
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#ifndef __STARTER_GFX_H
#define __STARTER_GFX_H

#define NB_STARTER_PALETTE_ENTRIES 256
extern const u16 starter_palette[NB_STARTER_PALETTE_ENTRIES]
   __attribute__ ((section (".rodata"))) ;

#define NB_STARTER_TILES 86
extern const u8 starter_tiles[NB_STARTER_TILES * 64]
   __attribute__ ((section (".rodata"))) ;
extern const u16 starter_map[30 * 20] __attribute__ ((section (".rodata"))) ;

#define NB_STARTER_FLAG_TILES_PER_FLAG 4
extern const u8 starter_flag_yes_tiles[NB_STARTER_FLAG_TILES_PER_FLAG * 64]
  __attribute__ ((section (".rodata"))) ;

extern const u8 starter_flag_no_tiles[NB_STARTER_FLAG_TILES_PER_FLAG * 64]
  __attribute__ ((section (".rodata"))) ;

#define FLAG_YES_TILE (NB_STARTER_TILES)
#define FLAG_NO_TILE (FLAG_YES_TILE + NB_STARTER_FLAG_TILES_PER_FLAG)

#define STARTER_OPTIONS_START_Y_OFFSET (2 * 8)
#define STARTER_OPTIONS_CHECK_WORD_Y_OFFSET (6 * 8)
#define STARTER_OPTIONS_RESTRICTED_TIME_Y_OFFSET (10 * 8)
#define STARTER_OPTIONS_SAVE_STATS_Y_OFFSET (14 * 8)
#define STARTER_OPTIONS_CLEAR_STATS_Y_OFFSET (18 * 8)

#define STARTER_OPTIONS_RIGHT_OFFSET (7 * 8)

/* Offsets non pas en pixels, mais en nombre de tiles ! */
#define STARTER_OPTIONS_CHECK_WORD_FLAG_Y_OFFSET 6
#define STARTER_OPTIONS_RESTRICTED_TIME_FLAG_Y_OFFSET 10
#define STARTER_FLAGS_RIGHT_OFFSET 9

#define SELECTION_START 0
#define SELECTION_CHECK_WORD 1
#define SELECTION_RESTRICTED_TIME 2
#define SELECTION_SAVE_STATS 3
#define SELECTION_CLEAR_STATS 4

#endif
